<?php 
defined( 'JPATH_BASE' ) or die( 'Restricted access' );

use LMS\Libraries\Installer;
use LMS\Libraries\Config\ConfigLoader;

class JLMSSystemMenu
{

    private static $_config;
    private static $_installer;
    private static $_tool_links;
    private static $sef_replacements;
    private static $replacement_dictionary = "Á|A, Â|A, Å|A, Ă|A, Ä|A, À|A, Ć|C, Ç|C, Č|C, Ď|D, É|E, È|E, Ë|E, Ě|E, Ì|I, Í|I, Î|I, Ï|I, Ĺ|L, Ń|N, Ň|N, Ñ|N, Ò|O, Ó|O, Ô|O, Õ|O, Ö|O, Ŕ|R, Ř|R, Š|S, Ś|O, Ť|T, Ů|U, Ú|U, Ű|U, Ü|U, Ý|Y, Ž|Z, Ź|Z, á|a, â|a, å|a, ä|a, à|a, ć|c, ç|c, č|c, ď|d, đ|d, é|e, ę|e, ë|e, ě|e, è|e, ì|i, í|i, î|i, ï|i, ĺ|l, ń|n, ň|n, ñ|n, ò|o, ó|o, ô|o, ő|o, ö|o, š|s, ś|s, ř|r, ŕ|r, ť|t, ů|u, ú|u, ű|u, ü|u, ý|y, ž|z, ź|z, ˙|-, ß|ss, Ą|A, µ|u, Ą|A, µ|u, ą|a, Ą|A, ę|e, Ę|E, ś|s, Ś|S, ż|z, Ż|Z, ź|z, Ź|Z, ć|c, Ć|C, ł|l, Ł|L, ó|o, Ó|O, ń|n, Ń|N, А|A, а|a, Б|B, б|b, В|V, в|v, Г|G, г|g, Д|D, д|d, Е|E, е|e, Ж|Zh, ж|zh, З|Z, з|z, И|I, и|i, Й|Y, й|y, К|K, к|k, Л|L, л|l, М|M, м|m, Н|N, н|n, О|O, о|o, П|P, п|p, Р|R, р|r, С|S, с|s, Т|T, т|t, У|U, у|u, Ф|F, ф|f, Х|Ch, х|ch, Ц|Ts, ц|ts, Ч|Ch, ч|ch, Ш|Sh, ш|sh, Щ|Sch, щ|sch, Ы|I, ы|i, Э|E, э|e, Ю|U, ю|iu, Я|Ya, я|ya, Ъ| , ъ| , Ь| , ь|";

    /***************** MENU CONFIG SECTION ****************/
    public static function getConfigParam( $param_name = '' )
    {
        if(is_null(self::$_config))
        {
           self::$_config = new ConfigLoader('config.lms_menu.json');
        }
        return self::$_config->getConfigParam($param_name);
    }

    public static function getInstaller()
    {
        if(is_null(self::$_installer))
        {
            self::$_installer = new Installer();
        }
        return self::$_installer;
    }

    /***************** MENU GENERATION SECTION ****************/


    public static function generateMenu()
	{
        $new_menu_id = null;
        $db = JFactory::getDbo();

        $lms_config_menu = JLMSSystemMenu::getConfigParam('menu');

        $db->setQuery('SELECT * FROM `#__menu_types` WHERE `menutype`="'.$lms_config_menu['menutype'].'" ');
        $lms_menu = $db->loadObject();
        if (isset($lms_menu->id))
        {
            $new_menu_id = $lms_menu->id;

            $db->setQuery('UPDATE `#__menu_types` SET `title`='.$db->quote($lms_config_menu['title']).',`description`='.$db->quote($lms_config_menu['description']).' WHERE id='.$new_menu_id);
            $db->execute();
        }

        if (!$new_menu_id)
        {
            $lms_menu = new stdClass();
            $lms_menu->menutype     = $lms_config_menu['menutype'];
            $lms_menu->title        = $lms_config_menu['title'];
            $lms_menu->description  = $lms_config_menu['description'];

            $db->setQuery('INSERT INTO `#__menu_types` (`id`,`menutype`,`title`,`description`)
                           VALUES (NULL, "'.$lms_menu->menutype.'","'.$lms_menu->title.'","'.$lms_menu->description.'")');
            $db->execute();
            $new_menu_id = $db->insertid();

            $lms_menu->id = $new_menu_id;
        }
        JLMSSystemMenu::synchronizeMenu($lms_menu);
		return $new_menu_id;
	}

    public static function synchronizeMenu( $lms_menu = null)
    {
        if (!$lms_menu->id)
        {
            return false;
        }

        //JLMSSystemMenu::createXrefTable();

        $lms_hidden_menu_items = JLMSSystemMenu::getAllLmsHiddenMenuItems();
        $xref_items = JLMSSystemMenu::getAllFromSystemMenu();
        if (sizeof($lms_hidden_menu_items)!=sizeof($xref_items))
        {
            JLMSSystemMenu::updateXrefMenuItemsByIds($lms_hidden_menu_items, $xref_items);
        }

        $component_id = JLMSSystemMenu::getLmsComponentId();

        $menu_elements = JLMSSystemMenu::getDefaultMenuElements();
        $menutype = $lms_menu->menutype;

       //echo '<pre>'; print_R($menu_elements); echo '</pre>'; die;

        $first_level_id = null;
        $parent_id = $level = 1;


        $first_level_elements = $menu_elements->first_level;
        if (sizeof($first_level_elements))
        {
            foreach($first_level_elements as $first_level_element)
            {
                $already_main_item = JLMSSystemMenu::getItemIdByTool('default');
                if ($already_main_item)
                {
                    $first_level_id = $already_main_item;
                }
                else
                {
                    JLMSSystemMenu::changeDefaultAliasLmsInAnotherMenuItems();

                    $first_level_element->component_id = $component_id;
                    //echo '<pre>'; print_R($first_level_element);
                    $first_level_id = JLMSSystemMenu::checkAndInsertMenuItem( $menutype, $first_level_element, $parent_id, $level);
                    if ($first_level_element->id) JLMSSystemMenu::updateModulesMenu($first_level_element->id, $first_level_id);
                    JLMSSystemMenu::checkAndInsertToSystemMenu($first_level_id, $first_level_element);
                }
            }
        }

        if ($first_level_id)
        {

            JLMSSystemMenu::updateOtherLmsMenuItems($first_level_id); //Update old lms links as alias!

            $second_level_id = null;
            $level = 2;
            $second_level_elements = $menu_elements->second_level;
                if (sizeof($second_level_elements))
                {
                    foreach($second_level_elements as $second_level_element)
                    {
                        $second_level_element->component_id = $component_id;
                        $result_level_id = JLMSSystemMenu::checkAndInsertMenuItem( $menutype, $second_level_element, $first_level_id, $level);
                        if ($second_level_element->title == 'Courses') $second_level_id = $result_level_id;

                        JLMSSystemMenu::checkAndInsertToSystemMenu($result_level_id, $second_level_element);
                    }
                }
        }

        if (isset($second_level_id))
        {
            $third_level_id = null;
            $level = 3;
            $third_level_elements = $menu_elements->third_level;
            if (sizeof($third_level_elements))
            {
                foreach($third_level_elements as $third_level_element)
                {
                    $third_level_element->component_id = $component_id;
                    $third_level_element->alias = $third_level_element->course_id.'-'.$third_level_element->alias;
                    $third_level_id = JLMSSystemMenu::checkAndInsertMenuItem( $menutype, $third_level_element, $second_level_id, $level);

                    JLMSSystemMenu::checkAndInsertToSystemMenu($third_level_id, $third_level_element);
                }
            }
        }

        return true;
    }

    public static function checkAndInsertToSystemMenu($el_item_id=0, $menu_element=null)
    {
        $el_item_id = (int)$el_item_id;
        if (!$el_item_id) return false;

        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
            $query->select('`id`');
            $query->from('`#__lms_system_menu_xref`');
            $query->where('`item_id`='.$el_item_id);
        $db->setQuery($query);
        $isset_system_menu_item = $db->loadResult();

        $xref_menu_item = new stdClass();
        $xref_menu_item->tool = $menu_element->tool;
        $xref_menu_item->item_id = $el_item_id;
        $xref_menu_item->course_id = $menu_element->course_id;

        if (!$isset_system_menu_item )
        {
            $db->insertObject('#__lms_system_menu_xref',$xref_menu_item);
        }
        else{
            $xref_menu_item->id = $isset_system_menu_item;
            $db->updateObject('#__lms_system_menu_xref',$xref_menu_item,'id');
        }
        return true;
    }

    public static function includeNativeMenuTable()
    {
        if (file_exists(JPATH_ADMINISTRATOR. '/components/com_menus/helpers/menus.php'))
        {
            require_once JPATH_ADMINISTRATOR. '/components/com_menus/helpers/menus.php';
            require_once JPATH_ADMINISTRATOR . '/components/com_menus/tables/menu.php';
            return true;
        }
        return false;
    }

    public static function checkAndInsertMenuItem( $menutype = '', $menu_element = null, $parent_id = 1 , $level = 1, $link_type = 'component' )
    {
        $db = JFactory::getDbo();
        $db->setQuery('SELECT `id` FROM `#__menu` WHERE `menutype`="'.$menutype.'" AND `link`="'.$menu_element->url.'" '); //AND `title`="'.$menu_element->title.'"
        $menu_item_id = $db->loadResult();

        if (!$menu_item_id)
        {
            JLMSSystemMenu::includeNativeMenuTable();

            if ($menu_element->alias)
            {
                $db->setQuery('SELECT `id`  FROM `#__menu` WHERE `alias`="'.$menu_element->alias.'"');
                $isset_item = $db->loadResult();
                if (!$isset_item) $menu_element->alias = null;
            }

            $menu_table = JTable::getInstance('Menu','MenusTable');
            $data = array(
                'id' => 0,
                'title' => $menu_element->title,
                'alias' => ($menu_element->alias?$menu_element->alias:JLMSSystemMenu::generateUniqAlias($menu_element->title, isset($menu_element->course_id)?$menu_element->course_id:0)),
                'path'  => isset($menu_element->path)?$menu_element->path:'',
                'note' => '',
                'link' => $menu_element->url,
                'menutype' => $menutype,
                'level' => $level,
                'type' => $link_type,
                'published' => 1,
                'parent_id' => $parent_id,
                'component_id' => (int)$menu_element->component_id,
                'browserNav' => 0,
                'access' => (isset($menu_element->access)?$menu_element->access:1),
                'template_style_id' => (isset($menu_element->template_style_id)?$menu_element->template_style_id:0),
                'language' => (isset($menu_element->language)?$menu_element->language:'*'),
                'params' => $menu_element->params,
                'home' => (isset($menu_element->home)?$menu_element->home:0)
            );


            $menu_table->setLocation($data['parent_id'], 'last-child');

            if (!$menu_table->bind($data))
            {
                print_R($menu_table->getError());
                return false;
            }

            if (!$menu_table->store())
            {
                print_R($menu_table->getError());
                return false;
            }

            if (!$menu_table->rebuildPath($menu_table->id))
            {
                print_R($menu_table->getError());
                return false;
            }

            $menu_item_id =  $menu_table->id;
        }

        if (isset($menu_element->template_style_id))
        {
            JLMSSystemMenu::updateMenuItemTemplateId($menu_item_id,$menu_element->template_style_id);
        }

        if (isset($menu_element->modules))
        {
            $modules_ids = $menu_element->modules;
            if(sizeof($modules_ids))
            {
                foreach($modules_ids as $module_id)
                {
                    $db = JFactory::getDbo();
                    $db->setQuery('SELECT `moduleid` FROM `#__modules_menu` WHERE `menuid`='.$menu_item_id.' AND `moduleid`='.$module_id);
                    $module_isset = $db->loadResult();
                        if (!$module_isset)
                        {
                            JLMSSystemMenu::insertToModulesMenu( $menu_item_id, $module_id);
                        }
                }
            }
        }

        return $menu_item_id;
    }

    public static function insertToModulesMenu( $menu_id=0, $module_id=0, $type='')
    {
        if (!$menu_id || !$module_id) return false;

        $db = JFactory::getDbo();
        $db->setQuery('INSERT INTO `#__modules_menu` SET `menuid`='.$type.$menu_id.', `moduleid`='.$module_id);
        return $db->execute();
    }

    public static function updateModulesMenu($oldItemId=0, $newItemId=0)
    {
        if (!$newItemId) return false;

        $db = JFactory::getDbo();
        $db->setQuery('SELECT  `moduleid` FROM `#__modules_menu` WHERE `menuid`='.$oldItemId);
        $moduleids = $db->loadColumn();

        if (sizeof($moduleids))
        {
            foreach($moduleids as $modid)
            {
                $db->setQuery('SELECT `moduleid` FROM `#__modules_menu` WHERE `menuid`='.$newItemId.' AND `moduleid`='.$modid);
                $isset = $db->loadResult();
                if (!$isset)
                {
                    JLMSSystemMenu::insertToModulesMenu( $newItemId, $modid);
                }
            }
        }

        $db = JFactory::getDbo();
        $db->setQuery('SELECT  `moduleid` FROM `#__modules_menu` WHERE `menuid`=-'.$oldItemId);
        $moduleids = $db->loadColumn();

        if (sizeof($moduleids))
        {
            foreach($moduleids as $modid)
            {
                $db->setQuery('SELECT `moduleid` FROM `#__modules_menu` WHERE `menuid`=-'.$newItemId.' AND `moduleid`='.$modid);
                $isset = $db->loadResult();
                if (!$isset)
                {
                    JLMSSystemMenu::insertToModulesMenu( $newItemId, $modid, '-' );
                }
            }
        }
        return true;
    }

	public static function getDefaultMenuElements()
	{
        $default_main_item = JLMSSystemMenu::getDefaultMainItem();
		$elements = new stdClass();

        $elements->first_level[] = JLMSSystemMenu::getMainMenuItem( $default_main_item );

        $lms_config_second_level = JLMSSystemMenu::getConfigParam('menu_elements.second_level');

        if (sizeof($lms_config_second_level))
        {
            foreach ($lms_config_second_level as $second_level_element)
            {
                $menu_item_params = array();
                $menu_item_params = $second_level_element;
               // $elements->second_level[] = JLMSSystemMenu::newMenuItem( $second_level_element['title'], $second_level_element['tool'] , $second_level_element['url'] , $second_level_element['alias']);
                $elements->second_level[] = JLMSSystemMenu::newMenuItem( $menu_item_params );
            }
        }


        $lms_config_third_level = JLMSSystemMenu::getConfigParam('menu_elements.third_level');
        $courses = JLMSSystemMenu::getAllCourses();
        if (sizeof($courses))
        {
            foreach ($courses as $course)
            {
                $menu_item_params = array();
                $menu_item_params = $lms_config_third_level;
                $menu_item_params['title'] = $course->course_name;
                $menu_item_params['url'] = $lms_config_third_level['url'].$course->id;
                $menu_item_params['course_id'] = $course->id;
                $elements->third_level[] = JLMSSystemMenu::newMenuItem($menu_item_params);
            }
        }

		return $elements;		
	}

    public static function getMainMenuItem( $defitem = null)
    {
        $menu_item = new stdClass();
        $menu_item->id          = isset($defitem->id)?$defitem->id:null;
        $menu_item->title       = $defitem->title;
        $menu_item->alias       = $defitem->alias;
        $menu_item->path        = $defitem->path;
        $menu_item->url         = $defitem->link;
        $menu_item->params      = $defitem->params;
        $menu_item->type        = $defitem->type;
        $menu_item->access      = 1; //$defitem->access;
        $menu_item->home        = $defitem->home;
        $menu_item->language    = $defitem->language;
        $menu_item->client_id    = $defitem->client_id;
        $menu_item->template_style_id  = $defitem->template_style_id;
        $menu_item->component_id = $defitem->component_id;
        $menu_item->tool = 'default';
        $menu_item->course_id = 0;
        if (isset($defitem->modules)) $menu_item->modules = $defitem->modules;
        return $menu_item;
    }

    public static function newMenuItem( $params = array())
    {
        $menu_item = new stdClass();
        $menu_item->title       = (isset($params['title'])?$params['title']:'');
        $menu_item->url         = (isset($params['url'])?$params['url']:'');
        $menu_item->alias       = (isset($params['alias'])?$params['alias']:JFilterOutput::stringURLSafe(JLMSSystemMenu::UTFReplaceForAlias($menu_item->title)));
        $menu_item->component_id = (isset($params['component_id'])?$params['component_id']:JLMSSystemMenu::getLmsComponentId());
        $menu_item->params      = (isset($params['params'])?$params['params']:'');
        $menu_item->type        = (isset($params['type'])?$params['type']:'url');
        $menu_item->tool        = (isset($params['tool'])?$params['tool']:'');
        $menu_item->course_id   = (isset($params['course_id'])?$params['course_id']:0);

        $template_style_id  = 0;
        if (isset($params['template_name'])) {
            $template_style_id = (int)JLMSSystemMenu::getInstaller()->getTemplateId($params['template_name']);
        }

        if (isset($params['modules'])) {
            $item_modules = $params['modules'];
            if(sizeof($item_modules))
            {
                foreach($item_modules as $module_params)
                {
                    $menu_item->modules[] = (int)JLMSSystemMenu::getInstaller()->getModuleId($module_params['module_name'], $module_params['module_position']);
                }
            }
        }
        $menu_item->template_style_id  = $template_style_id;
        return $menu_item;
    }

	public static function newMenuItemOld( $title='', $tool='', $url='', $alias='', $course_id=0, $type='url')
	{
		$menu_item = new stdClass();
		$menu_item->title = $title;
		$menu_item->url = $url;
        $menu_item->alias = ($alias?$alias:JFilterOutput::stringURLSafe(JLMSSystemMenu::UTFReplaceForAlias($title)));
        $menu_item->component_id = 0;
        $menu_item->params = '';
        $menu_item->type = $type;
        $menu_item->tool = $tool;
        $menu_item->course_id = (int)$course_id;

		return $menu_item;
	}

    public static function getDefaultMainItem()
    {
        $lms_items = JLMSSystemMenu::getAllLmsMenuItems();
        $default_main_item = null;

        $homepage_link = "index.php?option=com_joomla_lms&view=default";
        $courses_link = "index.php?option=com_joomla_lms&view=courses";

        if (sizeof($lms_items))
        {
            $lms_home_menutype = JLMSSystemMenu::getPremiunMenuType();

            if ($lms_items[0]->type == 'component') $default_main_item = $lms_items[0];
            foreach($lms_items as $lms_menu_item)
            {
                if ($lms_menu_item->type == 'alias') continue;

                    if ($lms_menu_item->published==1 && $default_main_item->published==0)
                    {
                        $default_main_item = $lms_menu_item;
                        continue;
                    }

                    if ($lms_menu_item->menutype == $lms_home_menutype && $lms_menu_item->published==1)
                    {
                        if ($default_main_item->menutype!= $lms_home_menutype)
                        {
                            $default_main_item = $lms_menu_item;
                        }
                    }

                    if ($lms_menu_item->link == $homepage_link && $lms_menu_item->published==1 && $default_main_item->link == $courses_link)
                    {
                        $default_main_item = $lms_menu_item;
                    }
            }

            if (isset($default_main_item->type))
            {
                if ($default_main_item->type == 'component')
                {
                    JLMSSystemMenu::setRandomAlias($default_main_item->id);
                }
            }
        }

        if (!isset($default_main_item->id)) $default_main_item = JLMSSystemMenu::getDefaultHiddenMenuMainElement();

        $lms_config_first_level = JLMSSystemMenu::getConfigParam('menu_elements.first_level');

        if (!isset($default_main_item->id))
        {

            $component_id = JLMSSystemMenu::getLmsComponentId();
            $default_main_item = new stdClass();
            $default_main_item->title = $lms_config_first_level['title'];
            $default_main_item->alias = $lms_config_first_level['alias'];
            $default_main_item->path = $lms_config_first_level['path'];
            $default_main_item->link = $lms_config_first_level['url'];
            $default_main_item->params = $lms_config_first_level['params'];
            $default_main_item->type = $lms_config_first_level['type'];
            $default_main_item->access = $lms_config_first_level['access'];
            $default_main_item->home = $lms_config_first_level['home'];
            $default_main_item->language = $lms_config_first_level['language'];
            $default_main_item->client_id = $lms_config_first_level['client_id'];
            $default_main_item->template_style_id = (int)JLMSSystemMenu::getInstaller()->getTemplateId($lms_config_first_level['template_name']);
            $default_main_item->component_id = (int)$component_id;

        }

        if (isset($lms_config_first_level['modules'])) {
            $item_modules = $lms_config_first_level['modules'];
            if(sizeof($item_modules))
            {
                foreach($item_modules as $module_params)
                {
                    $default_main_item->modules[] = (int)JLMSSystemMenu::getInstaller()->getModuleId($module_params['module_name'], $module_params['module_position']);
                }
            }

        }
        return $default_main_item;
    }

    public static function changeDefaultAliasLmsInAnotherMenuItems()
    {
        $lms_items = JLMSSystemMenu::getAllLmsMenuItems();
        if (sizeof($lms_items))
        {
            foreach($lms_items as $lms_menu_item)
            {
                if ($lms_menu_item->alias == JLMSSystemMenu::getConfigParam('menu_elements.first_level.alias'))
                {
                    JLMSSystemMenu::setRandomAlias( $lms_menu_item->id);
                }
            }
        }
    }

    public static function updateOtherLmsMenuItems($default_main_item_id=0)
    {

        $buf_orig_itemid = $default_main_item_id;
        $lms_items = JLMSSystemMenu::getAllLmsMenuItems();
        if (sizeof($lms_items))
        {
            foreach($lms_items as $lms_menu_item)
            {
                switch ($lms_menu_item->link) {
                    case  'index.php?option=com_joomla_lms&task=courses':
                    case  'index.php?option=com_joomla_lms&task=details_course':
                        $courses_item_id = JLMSSystemMenu::getItemIdByTool('courses');
                        if ($courses_item_id) $default_main_item_id = $courses_item_id;
                    break;
                    case  'index.php?option=com_joomla_lms&task=outdocs':
                        $additional_item_id = JLMSSystemMenu::getItemIdByTool('outdocs');
                        if ($additional_item_id) $default_main_item_id = $additional_item_id;
                    break;
                    case  'index.php?option=com_joomla_lms&task=coursebuilder.builder.show':
                        $additional_item_id = JLMSSystemMenu::getItemIdByTool('course_builder');
                        if ($additional_item_id) $default_main_item_id = $additional_item_id;
                    break;
                    case  'index.php?option=com_joomla_lms&task=global_pool':
                        $additional_item_id = JLMSSystemMenu::getItemIdByTool('global_pool');
                        if ($additional_item_id) $default_main_item_id = $additional_item_id;
                    break;
                    case  'index.php?option=com_joomla_lms&task=subscription':
                        $additional_item_id = JLMSSystemMenu::getItemIdByTool('subscription');
                        if ($additional_item_id) $default_main_item_id = $additional_item_id;
                    break;
                    default:
                        $default_main_item_id = $buf_orig_itemid;
                    break;
                }

                $lms_menu_item->type = 'alias';
                if (isset($lms_menu_item->params))
                {
                    $comp_params = json_decode($lms_menu_item->params);
                    if (!$comp_params) $comp_params = new stdClass();
                    $comp_params->aliasoptions = $default_main_item_id;
                    $lms_menu_item->params = json_encode($comp_params);
                }else
                {
                    $comp_params = new stdClass();
                    $comp_params->aliasoptions = $default_main_item_id;
                    $lms_menu_item->params = json_encode($comp_params);
                }

                $db = JFactory::getDbo();
                $db->updateObject('#__menu', $lms_menu_item, 'id');
            }
        }
        return true;
    }

    public static function UTFReplaceForAlias($alias='')
    {
        if (!self::$sef_replacements)
        {
            $replacement_disc = self::$replacement_dictionary;
            $replacement = "-";
            $str = trim( $replacement_disc );
            if( $str != '' ) {
                $items = explode(',', $str);
                foreach ($items as $item) {
                    @list ($src, $dst) = explode('|', trim($item));

                    // $dst can be empty, so the character can be removed
                    if( trim($src) == '' ) {
                        continue;
                    }
                    $replacements[trim($src)] = trim($dst);
                }
            }
            self::$sef_replacements = $replacements;
        }
        $replacement = '-';
        $replacements = self::$sef_replacements;
        // remove accented characters
        $title = strtr($alias, $replacements);
        // remove quotes, spaces, and other illegal characters
        $title = preg_replace(array('/\'/', '/[^a-zA-Z0-9\,!+]+/', '/(^_|_$)/'), array('', $replacement, ''), $title);
        $title = rtrim( $title, '-' );
        $title = rtrim( $title, '.' );
        // Handling lower case
        $alias = strtolower($title);

        return $alias;
    }
    public static function generateUniqAlias($title, $course_id=0)
    {
        $alias = JFilterOutput::stringURLSafe(JLMSSystemMenu::UTFReplaceForAlias($title));
        if ($course_id) $alias = $course_id.'-'.$alias;
        $db = JFactory::getDbo();
        $db->setQuery('SELECT `id`  FROM `#__menu` WHERE `alias`="'.$alias.'"');
        $isset_item = $db->loadResult();
        if ( $isset_item )
        {
            $alias = $alias.'-'.$course_id;
        }
        return $alias;
    }

    public static function setRandomAlias($item_id=0, $old_alias='')
    {
        if (!$old_alias) $old_alias = $item_id;//rand(1,1000);
        $db = JFactory::getDbo();

        $query = $db->getQuery(true);
        $query->update('#__menu');
        $query->set('`alias`='.$db->quote('jlms_alias_for_'.$old_alias));
        $query->where('`id`='.$item_id);
        $db->setQuery($query);
        return $db->execute();
    }

    public static function updateMenuItemTemplateId($item_id=0, $template_id=0)
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->update('#__menu');
        $query->set('`template_style_id`='.(int)$template_id);
        $query->where('`id`='.$item_id);
        $db->setQuery($query);
        return $db->execute();
    }

    public static function getLmsTemplateId()
    {
        $db = JFactory::getDbo();
        $db->setQuery('SELECT `id` FROM `#__template_styles` WHERE `template`="joomlalms"');
        return $db->loadResult();
    }

    public static function getAllCourses()
    {
        $courses = null;
        $db = JFactory::getDbo();
        $db->setQuery('SELECT `id`,`course_name`  FROM `#__lms_courses`');
        $courses = $db->loadObjectList();
        return $courses;
    }

    public static function getLmsComponentId()
    {
        $db = JFactory::getDbo();
        $db->setQuery('SELECT `extension_id` FROM `#__extensions` WHERE `element`="com_joomla_lms"');
        return $db->loadResult();
    }
    public static function getAllowedLinks()
    {
        $allow_links = array();
        $allow_links[] = "index.php?option=com_joomla_lms&view=default";
        $allow_links[] = "index.php?option=com_joomla_lms&view=courses";
        $allow_links[] = "index.php?option=com_joomla_lms&task=default";
        $allow_links[] = "index.php?option=com_joomla_lms&task=courses";
        $allow_links[] = "index.php?option=com_joomla_lms&task=outdocs";
        $allow_links[] = "index.php?option=com_joomla_lms&task=coursebuilder.builder.show";
        $allow_links[] = "index.php?option=com_joomla_lms&task=global_pool";
        $allow_links[] = "index.php?option=com_joomla_lms&task=subscription";
        $allow_links[] = "index.php?option=com_joomla_lms&task=details_course";
        return $allow_links;
    }

    public static function getAllLmsMenuItems()
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('*');
        $query->from('#__menu');
        $query->where('(`link`="index.php?option=com_joomla_lms&view=default"
                     OR `link`="index.php?option=com_joomla_lms&view=courses"
                     OR `link`="index.php?option=com_joomla_lms&task=default"
                     OR `link`="index.php?option=com_joomla_lms&task=courses"
                     OR `link`="index.php?option=com_joomla_lms&task=outdocs"
                     OR `link`="index.php?option=com_joomla_lms&task=coursebuilder.builder.show"
                     OR `link`="index.php?option=com_joomla_lms&task=global_pool"
                     OR `link`="index.php?option=com_joomla_lms&task=subscription"
                     OR (`link` LIKE "index.php?option=com_joomla_lms&task=details_course%")
                     )');
        $query->where('`menutype`<>"'.JLMSSystemMenu::getConfigParam('menu.menutype').'"');
       // $query->where('`type`<>"alias"');
        $query->order('`parent_id` ASC');
        $db->setQuery($query);
        return $db->loadObjectList();
    }

    public static function getDefaultHiddenMenuMainElement()
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('*');
        $query->from('#__menu');
        $query->where('(`link`="index.php?option=com_joomla_lms&task=default")');
        $query->where('`menutype`="'.JLMSSystemMenu::getConfigParam('menu.menutype').'"');
        $query->where('`type`="component"');
        $query->order('`parent_id` ASC');
        $db->setQuery($query);
        return $db->loadObject();
    }

    public static function getAllLmsHiddenMenuItems()
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('*');
        $query->from('#__menu');
        $query->where('`menutype`="'.JLMSSystemMenu::getConfigParam('menu.menutype').'"');
        $db->setQuery($query);
        return $db->loadObjectList();
    }

    public static function getPremiunMenuType()
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('`menutype`');
        $query->from('#__menu');
        $query->where('`home`=1');
        $db->setQuery($query);
        return $db->loadResult();
    }

    public static function updateXrefMenuItemsByIds($lms_hidden_menu_items=null, $xref_items=null)
    {
        $db = JFactory::getDbo();
        if (sizeof($lms_hidden_menu_items)==0)
        {
            $query = $db->getQuery(true);
            $query->delete('`#__lms_system_menu_xref`');
            $db->setQuery($query);
            $db->execute();
        }else
        {
            $sys_menu_items_id = array();
            foreach ($lms_hidden_menu_items as $lhmi)
            {
                $sys_menu_items_id[] = $lhmi->id;
            }
            if (sizeof($sys_menu_items_id))
            {
                $query = $db->getQuery(true);
                $query->delete('`#__lms_system_menu_xref`');
                $query->where('`item_id` NOT IN ('.implode(',',$sys_menu_items_id).')');
                $db->setQuery($query);
                $db->execute();
            }
        }
    }

    /***************** URL&ITEMID SECTION ****************/

    public static function getAllFromSystemMenu()
    {
        //JLMSSystemMenu::createXrefTable();
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('*');
            $query->from('`#__lms_system_menu_xref`');
            $db->setQuery($query);
        return  $db->loadObjectList();
    }

    public static function getItemIdByTool($tool='', $course_id=0)
    {
            $tools_with_course_id = JLMSSystemMenu::getAllowedToolsWithCourseId();
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('`item_id`');
            $query->from('`#__lms_system_menu_xref`');

            if (in_array($tool,$tools_with_course_id) && $course_id)
            {
                $query->where('`course_id`='.(int)$course_id);
                $tool = 'details_course'; //!Important. Need for disable duplicate tool names in db table.
            }
            $query->where('`tool`='.$db->quote($tool));
            $db->setQuery($query);

            $system_tool_alias = $tool.($course_id?$course_id:'');
                if (isset(self::$_tool_links[$system_tool_alias]))
                {
                    return self::$_tool_links[$system_tool_alias];
                }else
                {
                    /*
                    echo '<pre> SMT DEBUG: '; print_R($query->__toString()); echo'</pre>';
                    echo '<pre> SMT DEBUG: '; print_R($system_tool_alias); echo'</pre>';
                    echo '<pre> SMT DEBUG: '; print_R( self::$_tool_links); echo'</pre>';
                    */
                    $result_item_id = $db->loadResult();
                    self::$_tool_links[$system_tool_alias] = $result_item_id;
                    return $result_item_id;
                }
        return false;
    }


    public static function unparse_url($parsed_url)
    {
        $scheme   = isset($parsed_url['scheme']) ? $parsed_url['scheme'] . '://' : '';
        $host     = isset($parsed_url['host']) ? $parsed_url['host'] : '';
        $port     = isset($parsed_url['port']) ? ':' . $parsed_url['port'] : '';
        $user     = isset($parsed_url['user']) ? $parsed_url['user'] : '';
        $pass     = isset($parsed_url['pass']) ? ':' . $parsed_url['pass']  : '';
        $pass     = ($user || $pass) ? "$pass@" : '';
        $path     = isset($parsed_url['path']) ? $parsed_url['path'] : '';
        $query    = isset($parsed_url['query']) ? '?' . $parsed_url['query'] : '';
        $fragment = isset($parsed_url['fragment']) ? '#' . $parsed_url['fragment'] : '';
        return "$scheme$user$pass$host$port$path$query$fragment";

    }

    public static function getAllowedToolsWithCourseId()
    {
        $tools_with_course_id = array();
        $tools_with_course_id[] = 'details_course';
        $tools_with_course_id[] = 'settings';
        $tools_with_course_id[] = 'edit_course';
        $tools_with_course_id[] = 'mailbox';
        $tools_with_course_id[] = 'tracking';
        $tools_with_course_id[] = 'gradebook';
        $tools_with_course_id[] = 'conference';
        $tools_with_course_id[] = 'chat';
        $tools_with_course_id[] = 'course_forum';
        $tools_with_course_id[] = 'attendance';
        $tools_with_course_id[] = 'homework';
        $tools_with_course_id[] = 'dropbox';
        $tools_with_course_id[] = 'quizzes';
        $tools_with_course_id[] = 'links';
        $tools_with_course_id[] = 'agenda';
        $tools_with_course_id[] = 'documents';
        $tools_with_course_id[] = 'learnpaths';
        $tools_with_course_id[] = 'course_guest';
        $tools_with_course_id[] = 'announcements.announcement';
        return $tools_with_course_id;
    }

    public static function getSefLink($value)
    {
        $url = str_replace('&amp;', '&', $value);
        $url_array = parse_url($url);
        if (isset($url_array['query']))
        {
            $url_query = $url_array['query'];
            parse_str($url_query, $url_query_params);
            if (sizeof($url_query_params))
            {
                if (isset($url_query_params['task']) || isset($url_query_params['view']))
                {
                    if (isset($url_query_params['task']))
                        if ($url_query_params['task']=='agenda') {$url_query_params['task']='announcements';}


                        $course_id = (isset($url_query_params['course_id'])?(int)$url_query_params['course_id']:(isset($url_query_params['id'])?(int)$url_query_params['id']:0));
                        $tool = (isset($url_query_params['task'])?$url_query_params['task']:($url_query_params['view']?$url_query_params['view']:''));
                        $step_id = isset($url_query_params['step'])?(int)$url_query_params['step']:0;

                        if ($tool == 'change_course') {$tool = 'details_course';}
                        if ($tool == 'mailbox.message.show') {$tool = 'details_course';}
                        if ($tool == 'coursebuilder.builder.show') {$tool = 'course_builder';}
                        if ($tool == 'course_builder' && $course_id && $step_id==5)
                        {

                            $tool = 'details_course';
                        }
                    /*
                        if ($tool=='quizzes' && isset($url_query_params['page']))
                        {
                            if ($url_query_params['page']=='setup_gqp')
                            {
                                $tool=$url_query_params['page'];
                            }
                        }
                    */
                        //check tool function
                        if ($tool)
                        {
                            $new_item_id = JLMSSystemMenu::getItemIdByTool($tool, $course_id);
                            if ($new_item_id) $url_query_params['Itemid'] = (int) $new_item_id;
                        }
                        //update url function
                        $url_array['query'] = http_build_query($url_query_params);
                        $res_url = JLMSSystemMenu::unparse_url($url_array);

                        //echo '<pre> BEFORE: '; print_R($url); echo '</pre>';
                        $url = $res_url;
                        //echo '<pre> AFTER: '; print_R($url); echo '</pre>';
                }
            }
        }
      return $url;
    }

    public static function createCourseMenuLink($course_id=0, $course_name_post='')
    {
        $alias = JLMSSystemMenu::generateUniqAlias($course_name_post, $course_id);

        $parent_id = JLMSSystemMenu::getItemIdByTool('courses');

        $lms_config_third_level = JLMSSystemMenu::getConfigParam('menu_elements.third_level');
        $menu_item_params = array();
        $menu_item_params = $lms_config_third_level;
        $menu_item_params['title'] = $course_name_post;
        $menu_item_params['url'] = $lms_config_third_level['url'].$course_id;
        $menu_item_params['course_id'] = $course_id;
        $menu_item_params['alias'] = $alias;
        $menu_element = JLMSSystemMenu::newMenuItem( $menu_item_params );

        if ($parent_id)
        {
            $result_item_id = JLMSSystemMenu::checkAndInsertMenuItem( JLMSSystemMenu::getConfigParam('menu.menutype'), $menu_element, $parent_id , 3 );
            if ($result_item_id)
            {
                $xref_menu_item = new stdClass();
                $xref_menu_item->tool = 'details_course';
                $xref_menu_item->item_id = $result_item_id;
                $xref_menu_item->course_id = $course_id;

                return JLMSSystemMenu::checkAndInsertToSystemMenu($result_item_id, $xref_menu_item);
            }
        }
        return false;
    }

    public  static function deleteCourseMenuLink( $course_id=0 )
    {
        $db = JFactory::getDbo();

        $course_item_id = JLMSSystemMenu::getItemIdByTool('details_course', $course_id);
        if ($course_item_id)
        {
            $query = $db->getQuery(true);
            $query->delete('`#__lms_system_menu_xref`');
            $query->where('`item_id`='.$course_item_id);
            $query->where('`course_id`='.$course_id);
            $query->where('`tool`= "details_course"');
            $db->setQuery($query);
            $db->execute();

            JLMSSystemMenu::includeNativeMenuTable();
            $menu_table = JTable::getInstance('Menu','MenusTable');
            return $menu_table->delete($course_item_id);
        }
        return false;
    }

    public static function updateCourseMenuLink($course_id=0, $course_name_post='')
    {
        $course_item_id = JLMSSystemMenu::getItemIdByTool('details_course', $course_id);

        if ($course_item_id)
        {
            JLMSSystemMenu::includeNativeMenuTable();
            $menu_table = JTable::getInstance('Menu','MenusTable');
            $menu_table->load($course_item_id);

            if ($menu_table->title != $course_name_post)
            {

                $alias = JLMSSystemMenu::generateUniqAlias($course_name_post, $course_id);
                $menu_table->title = $course_name_post;
                $menu_table->alias = $alias;
                if ($menu_table->id)
                {
                    if (!$menu_table->store()) return false;
                    if (!$menu_table->rebuildPath($menu_table->id)) return false;
                }
            }
        } else
        {
            return JLMSSystemMenu::createCourseMenuLink($course_id, $course_name_post);
        }
        return false;
    }

    /*Temp function for create LMS system menu*/
    public static function createXrefTable()
    {
        $db = JFactory::getDbo();
        $db->setQuery('CREATE TABLE IF NOT EXISTS `#__lms_system_menu_xref` (
                        `id` int(11) NOT NULL AUTO_INCREMENT,
                      `tool` varchar(255) NOT NULL,
                      `item_id` int(10) unsigned NOT NULL,
                      `course_id` int(11) NOT NULL,
                      PRIMARY KEY (`id`))');
        return $db->execute();
    }

    /*Temp function for set templateId to LMS system menu items*/
    public static function updateTemplateIdForLmsLinks()
    {return;
        $allItems = JLMSSystemMenu::getAllFromSystemMenu();
        $defaultLmsTemplateId = (int)JLMSSystemMenu::getLmsTemplateId();
        if (sizeof($allItems) && $defaultLmsTemplateId)
        {
            $db = JFactory::getDbo();
            foreach ($allItems as $item)
            {
                if ($item->tool != 'courses' && $item->tool != 'default' && $item->tool != 'cart')
                {
                    $query = $db->getQuery(true);
                    $query->update('#__menu');
                    $query->set('`template_style_id`='.$defaultLmsTemplateId);
                    $query->where('`id`='.$item->item_id);
                    $db->setQuery($query);
                    $db->execute();
                }
            }
        }
    }

//end JLMSSystemMenu class
}
?>