<?php

namespace LMS\Tools\Conference\Table;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;

class Booking extends Base\Table
{
	var $p_id = null;
	var $course_id = null;
	var $teacher_id = null;
	var $from_time = null;
	var $to_time = null;
	var $public = null;
	var $p_name = null;
	var $p_description = 0;
	var $published = 1;

	protected $fieldMap = array(
		'id' => 'p_id'
	);

	protected $alias = 'booking';

	function __construct()
	{
		parent::__construct( '#__lms_conference_period', 'p_id' );
		$this->relations = array(
			'teacher' => array(
				'table' => ServiceLocator::get('userTable'),
				'type' => 'INNER',
				'condition' => '{parent.teacher_id} = {child.id}',
				'capacity' => self::ONE
			),
			'conference_user' => array(
				'table' => new User(),
				'type' => 'LEFT',
				'condition' => '{parent.p_id} = {child.p_id}',
				'capacity' => self::MANY
			),
		);
	}
}