<?php
namespace LMS\Tools\Coursebuilder\View;

use LMS\Libraries\Base;

defined('_JEXEC') or die;

class SetupModules extends Base\View
{
	protected $extension = 'com_joomla_lms';
	protected $viewName = 'SetupModules';

	public function __construct($config=array())
	{
		$this->viewDir = __DIR__;
		parent::__construct($config);
	}

	public function display($tpl = null)
	{
		return parent::display($tpl);
	}

	public function show()
	{

		$doc = \JFactory::getDocument();
		$renderer = $doc->loadRenderer('modules');
		$this->positionJlmsInline = $renderer->render('jlms-inline', array('style'=>'wellCustom'));

		\JHtml::_('jquery.ui', array('core', 'sortable'));
		$selector_elements_sortable = array();
		$selector_elements_sortable[] = '.jlms-cb-sortable';
		$selector = implode(', ', $selector_elements_sortable);
		$js = "
			jQuery(function() {
				jQuery('.jlms-cb-module-edit-buttons, .jlms-cb-add-module').fadeIn('slow');
				jQuery('".$selector."').parent().sortable({
					items: '>*:not(.jlms-cb-add-module)',
					containment: 'document',
					cursor: 'move',
					handle: '.page-header',
					axis: 'y',
					placeholder: {
						element: function(currentItem) {
							var el = jQuery('<div/>',{
								class: 'jlms-cb-sortable-placeholder'
							});
							el.css({
								width: (jQuery(currentItem[0]).innerWidth())+'px',
								height: jQuery(currentItem[0]).innerHeight()+'px',
								'margin-top': jQuery(currentItem[0]).css('margin-top'),
								'margin-right': jQuery(currentItem[0]).css('margin-right'),
								'margin-bottom': jQuery(currentItem[0]).css('margin-bottom'),
								'margin-left': jQuery(currentItem[0]).css('margin-left'),
							});
							return el;
						},
						update: function(container, p) {
							return;
						}
					},
					stop: function(event, ui){
						ui.item.removeAttr('style');
					},
					update: function(event, ui){
						var modules = jQuery(this).sortable('toArray');
						var cid = [];
						var order = [];
						modules.each(function(element, index){
							var res = element.match('jmod_(.+)');
							if(res){
								cid.push(res[1]);
								order.push(index + 1);
							}
						});

						var data = {};
						cid.each(function(element, index){
							jQuery(data).data('cid['+index+']', element);
						});
						order.each(function(element, index){
							jQuery(data).data('order['+index+']', element);
						});

						var el_notification_overlay = jQuery('<div/>', {
							class: 'jlms-cb-notification-state hide'
						}).css({
							'bodrer-radius': '4px',
							'background-color': '#fafafa',
							opacity: 0
						});
						//el_notification_overlay.appendTo(ui.item).fadeIn('slow');
						el_notification_overlay.appendTo(ui.item).fadeTo('slow', 0.7);

						var el_notification_state = jQuery('<div/>', {
							class: 'jlms-cb-notification-state hide'
						});
						var el_notification_state_text = jQuery('<div/>', {
							class: 'jlms-cb-notification-state-text'
						});
						var el_label = jQuery('<span/>', {
							class: 'label label-success'
						}).text('".\JText::_('_JLMS_SAVED')."');
						el_notification_state_text.append(el_label);
						el_notification_state.append(el_notification_state_text);

						var url = 'index.php?option=com_joomla_lms&task=coursebuilder.modules.saveOrderAjax&tmpl=component';
						jQuery.post(
							url,
							jQuery(data).data(),
							function(data){
								if(data){
									el_notification_state
										.appendTo(ui.item)
										.fadeIn('fast')
										.delay(1000)
										.fadeOut('slow', function(){
											jQuery(this).remove();
											el_notification_overlay
											.fadeTo('slow', 0, function(){
												jQuery(this).remove();
											});
										});
								}
							}
						);
					},
				}).disableSelection();
			});
			";
		$doc->addScriptDeclaration($js);

		$this->display();
	}
}