<?php
namespace LMS\Tools\Homework\Controllers;

use LMS\Libraries\Base;

defined('_JEXEC') or die;

class Results extends Base\Controller
{
	public function __construct($config=array())
	{
		parent::__construct($config);
	}

	public function show()
	{
		$courseId = $this->input->get('course_id', 0);
		$id = $this->input->get('id', 0);
		$filter = $this->input->get('filter', array(), 'array');
		$Itemid = $this->input->get('Itemid', 0);

		$filter['status'] = !isset($filter['status']) ? 1 : $filter['status'];
		$filter['user_id'] = !isset($filter['user_id']) ? 0 : $filter['user_id'];
		$filter['group_id'] = !isset($filter['group_id']) ? 0 : $filter['group_id'];

		$this->application->setUserState('com_joomla_lms.filter.course_id', (int)$courseId);
		$this->application->setUserState('com_joomla_lms.filter.status', (int)$filter['status']);
		$this->application->setUserState('com_joomla_lms.filter.user_id', (int)$filter['user_id']);
		$this->application->setUserState('com_joomla_lms.filter.group_id', (int)$filter['group_id']);

		$resultsModel = $this->getModel('Results', '', array('dbo'=>\JFactory::getDbo()));
		$resultsModel->setState('courseId', $courseId);
		$resultsModel->setState('homeworkId', $id);
		$resultsModel->setState('filter.status', $filter['status']);
		$resultsModel->setState('filter.user_id', $filter['user_id']);
		$resultsModel->setState('filter.group_id', $filter['group_id']);
		$this->populateModel($resultsModel);

		$homeworkModel = $this->getModel('Homework');
		$homeworkModel->setState('courseId', $courseId);
		$homeworkModel->setState('id', $id);
		$this->populateModel($homeworkModel);

		$view = $this->getView('Results');
		if($Itemid){
			$view->Itemid = $Itemid;
		}

		$view->setModel($resultsModel, true);
		$view->setModel($homeworkModel);

		$view->show();
	}

	public function cancel()
	{
		$jform = $this->input->get('jform', array(), 'array');
		$course_id = isset($jform['course_id']) ? $jform['course_id'] : $this->input->get('course_id', 0);

		$link = 'index.php?option=com_joomla_lms&task=homework.homeworks.show';
		$link .= '&course_id='.$course_id;
		$link .= '&Itemid='.$this->input->get('Itemid');

		$link = \JRoute::_($link, false);
		$link = html_entity_decode($link);

		$this->setRedirect($link);
	}
}