<?php
 
namespace LMS\Tools\Users\Model;
 
defined('_JEXEC') or die;

use LMS\Libraries;
use LMS\Libraries\Repository;
use LMS\Libraries\User;
use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;

class Staff extends Base\Model
{	
	var $context = 'staff';	
	
	var $modelDir = __DIR__;
		
	public function __construct()
	{			
		parent::__construct();		
	}		
	
	protected function loadFormData() 
	{
		$data = new \JObject();				
		$data->set('search', $this->getState('filter.search'));		

		return $data;
	}		
	
	public function getStaffNames($ids, $excludedIds) 
	{			
		if(empty($ids) && empty($excludedIds)) {
			$this->setState('user_id', array());
		} else {						
			if(!empty($ids)) {
				$this->setState('user_id', $ids);				
			}
			
			if(!empty($excludedIds)) {			
				$this->setState('excluded_user_id', $excludedIds);
			}		
		}
			
		$items = $this->getItems();
		
		$res = array();
		
		foreach($items AS $item) {
			$res[] = $item->name;
		}
		
		return $res;
	}
	
	protected function getListQuery()
	{
		$stateProperties = $this->getState()->getProperties();
		
		$repositoryStaff = ServiceLocator::get('staff_rep');
		$repositoryCourseStaff	= ServiceLocator::get('coursestaff_rep');
		
		$stateProperties['fields'] = 'staff.profile.name, staff.profile.email, staff.profile.id';
		
		$query = $repositoryStaff->getByFilterQuery($stateProperties);
		
		$stateProperties['fields'] = 'coursestaff.profile.name, coursestaff.profile.email, coursestaff.profile.id';
		
		$sub = $repositoryCourseStaff->getByFilterQuery($stateProperties);		
		
		$query->union($sub);	

		return $query;
	}
}