<?php

namespace LMS\Tools\Users\Repositories;

use LMS\Libraries\Base;
use LMS\Tools\Users\Tables;
use LMS\Libraries\Servicelocator;

class Group extends Base\Repository
{	
	public function __construct($options = array()) 
	{
		parent::__construct($options);
		
		$this->config = ServiceLocator::get('config');		
		$this->table = new Tables\Usergroups($this->db);				
	}
	
	protected function prepareFilter($query, &$filterOptions)
	{	
		$filters = (isset($filterOptions['list.filters']))?$filterOptions['list.filters']:array();
			
		if($this->config->get('use_global_groups')){
			$query->where('group.course_id = 0');			
		} else {
			$query->where('group.course_id = '.$this->config->get('course_id'));
		}
		
		if(isset($filterOptions['group_id']) && empty($filterOptions['group_id'])) {
			$filterOptions['group_id'] = array(-1);
		}
				
		if(!empty($filterOptions['group_id'])){
			if(is_array($filterOptions['group_id'])) {
				$strGroups = implode(',', $filterOptions['group_id']);
			} else {
				$strGroups = $filterOptions['group_id'];
			}
			
			$query->where('group.id IN ('.$strGroups.')');
		}
		
		if(!empty($filterOptions['numberStudentsInGroup'])){			
			if(is_string($filterOptions['fields'])) {
				$filterOptions['fields'] = explode(',', $filterOptions['fields']);
			}
			$filterOptions['fields'][] = 'COUNT(group.student.user_id) AS students_count';
			
			$query->group('group.id');
		}

		if(!empty($filterOptions['usersExistInGroups'])){
			$query->where('group.student.user_id IS NOT NULL');
			$query->group('group.id');
		}

		if(!empty($filterOptions['user_id']) && $filterOptions['user_id']){
			$query->where('group.student.user_id = '.$this->db->quote($filterOptions['user_id']));
		}
		
		if(!empty($filters['search'])) {
			$search = $filters['search'];
			$query->where('
				(
					UPPER(group.name) LIKE UPPER(\'%'.$search.'%\') 					
				)'				
			);			
		}

		return parent::prepareFilter($query, $filterOptions);
	}
}
?>