<?php
namespace LMS\Tools\Users\Tables;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;

class Usergroups extends Base\Table
{	
	protected $alias = 'group';
	
	protected $fieldMap = array(
		'name' => 'ug_name'
	);
	
	function __construct(&$db)
	{
		parent::__construct( '#__lms_usergroups', 'id', $db );		
	}
	
	protected function initRelations()
	{
		parent::initRelations(); // TODO: Change the autogenerated stub
		
		$config	= ServiceLocator::get('config');
		
		$this->relations = array();
		if($config->get('use_global_groups')){			
			$this->relations['student'] = array(
				'table' => new UsersInGlobalGroups($this->_db),
				'type' => 'LEFT',
				'condition' => '{parent.id} = {child.group_id}',
				'capacity' => self::MANY
			);		
		} else {		
			$this->relations['student'] = array(
				'table' => new UsersInGroups($this->_db),
				'type' => 'LEFT',
				'condition' => '{parent.id} = {child.group_id}',
				'capacity' => self::MANY
			);
		}
	}
}
?>